module Main where
import System.Environment (getArgs)

import qualified Test.DMuCheck.Master as Master

localHost, localPort :: String
localHost = "127.0.0.1"
localPort = "10501"

help :: IO ()
help = do putStrLn "d-master <fn> <file> <props..>"
          putStrLn "E.g."
          putStrLn "  d-master qsort Examples/QuickCheckTest.hs 'quickCheckResult revProp' 'quickCheckResult modelProp'"

main :: IO ()
main = do
  args <- getArgs
  case args of
    ("-h":_) -> help
    (fn : file : props) -> Master.process localHost localPort fn file props
    _ -> putStrLn "use -h to get help."

